from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, String

Rseg_Diff_V0_1_0 = CommandToolBuilder(tool="rseg_diff", base_command=["rseg-diff"], inputs=[ToolInput(tag="in_out", input_type=File(optional=True), prefix="-out", doc=InputDocumentation(doc="domain output file")), ToolInput(tag="in_score", input_type=Boolean(optional=True), prefix="-score", doc=InputDocumentation(doc="Posterior scores file")), ToolInput(tag="in_read_count", input_type=Boolean(optional=True), prefix="-readcount", doc=InputDocumentation(doc="readcounts file")), ToolInput(tag="in_boundary", input_type=Boolean(optional=True), prefix="-boundary", doc=InputDocumentation(doc="domain boundary file")), ToolInput(tag="in_boundary_score", input_type=Boolean(optional=True), prefix="-boundary-score", doc=InputDocumentation(doc="boundary transition scores file")), ToolInput(tag="in_chrom", input_type=Boolean(optional=True), prefix="-chrom", doc=InputDocumentation(doc="file with chromosome sizes (BED format)")), ToolInput(tag="in_dead_zones", input_type=Boolean(optional=True), prefix="-deadzones", doc=InputDocumentation(doc="file of deadzones (BED format)")), ToolInput(tag="in_bam", input_type=Boolean(optional=True), prefix="-bam", doc=InputDocumentation(doc="Input reads file is BAM format")), ToolInput(tag="in_param_in", input_type=Boolean(optional=True), prefix="-param-in", doc=InputDocumentation(doc="Input parameters file")), ToolInput(tag="in_param_out", input_type=File(optional=True), prefix="-param-out", doc=InputDocumentation(doc="Output parameters file")), ToolInput(tag="in_mode", input_type=Boolean(optional=True), prefix="-mode", doc=InputDocumentation(doc="running mode 2:test-control; 3: test-test")), ToolInput(tag="in_max_it_r", input_type=Boolean(optional=True), prefix="-maxitr", doc=InputDocumentation(doc="maximum iterations for training")), ToolInput(tag="in_bin_size", input_type=Boolean(optional=True), prefix="-bin-size", doc=InputDocumentation(doc="bin size (default: based on data)")), ToolInput(tag="in_bin_step", input_type=Boolean(optional=True), prefix="-bin-step", doc=InputDocumentation(doc="minimum bin size (default: 50)")), ToolInput(tag="in_duplicates", input_type=Boolean(optional=True), prefix="-duplicates", doc=InputDocumentation(doc="keep duplicate reads")), ToolInput(tag="in_fragment_length", input_type=Boolean(optional=True), prefix="-fragment_length", doc=InputDocumentation(doc="Extend reads to fragment length (default not to\nextend)")), ToolInput(tag="in_waterman", input_type=Boolean(optional=True), prefix="-Waterman", doc=InputDocumentation(doc="use Waterman's method for bin size")), ToolInput(tag="in_hideaki", input_type=Boolean(optional=True), prefix="-Hideaki", doc=InputDocumentation(doc="use Hideaki's method for bin size")), ToolInput(tag="in_hideaki_emp", input_type=Boolean(optional=True), prefix="-Hideaki-emp", doc=InputDocumentation(doc="use Hideaki's empirical method (default)")), ToolInput(tag="in_smooth", input_type=Boolean(optional=True), prefix="-smooth", doc=InputDocumentation(doc="Indicate whether the rate curve is assumed smooth")), ToolInput(tag="in_max_dead", input_type=Boolean(optional=True), prefix="-max-dead", doc=InputDocumentation(doc="max deadzone proportion for retained bins")), ToolInput(tag="in_domain_size", input_type=Boolean(optional=True), prefix="-domain-size", doc=InputDocumentation(doc="expected domain size (default: 20000)")), ToolInput(tag="in_desert", input_type=Boolean(optional=True), prefix="-desert", doc=InputDocumentation(doc="desert size (default: 20000)")), ToolInput(tag="in_fg", input_type=Boolean(optional=True), prefix="-fg", doc=InputDocumentation(doc="foreground emission distribution")), ToolInput(tag="in_bg", input_type=Boolean(optional=True), prefix="-bg", doc=InputDocumentation(doc="background emission distribution")), ToolInput(tag="in_training_size", input_type=Boolean(optional=True), prefix="-training-size", doc=InputDocumentation(doc="Max number of data points for training (default: all)")), ToolInput(tag="in_posterior", input_type=Boolean(optional=True), prefix="-posterior", doc=InputDocumentation(doc="use posterior decoding (default: Viterbi)")), ToolInput(tag="in_posterior_cut_off", input_type=Boolean(optional=True), prefix="-posterior-cutoff", doc=InputDocumentation(doc="Posterior threshold for signigicant bins")), ToolInput(tag="in_undefined", input_type=Boolean(optional=True), prefix="-undefined", doc=InputDocumentation(doc="min size of unmappable region")), ToolInput(tag="in_cut_off", input_type=Boolean(optional=True), prefix="-cutoff", doc=InputDocumentation(doc="cutoff in cdf for identified domains")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="-verbose", doc=InputDocumentation(doc="print more run information")), ToolInput(tag="in_about", input_type=Boolean(optional=True), prefix="-about", doc=InputDocumentation(doc="print about message")), ToolInput(tag="in_mapped_read_locations_a", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_mapped_read_locations_b", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="domain output file")), ToolOutput(tag="out_param_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_param_out", type_hint=File()), doc=OutputDocumentation(doc="Output parameters file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Rseg_Diff_V0_1_0().translate("wdl", allow_empty_container=True)

